Merge branch 'stable-2.9'
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/Cpu \
72         src/Ganeti/DataCollectors \
73         src/Ganeti/Hs2Py \
74         src/Ganeti/HTools \
75         src/Ganeti/HTools/Backend \
76         src/Ganeti/HTools/Program \
77         src/Ganeti/Hypervisor \
78         src/Ganeti/Hypervisor/Xen \
79         src/Ganeti/Monitoring \
80         src/Ganeti/Query \
81         src/Ganeti/Storage \
82         src/Ganeti/Storage/Diskstats \
83         src/Ganeti/Storage/Drbd \
84         src/Ganeti/Storage/Lvm \
85         test/hs \
86         test/hs/Test \
87         test/hs/Test/Ganeti \
88         test/hs/Test/Ganeti/Storage \
89         test/hs/Test/Ganeti/Storage/Diskstats \
90         test/hs/Test/Ganeti/Storage/Drbd \
91         test/hs/Test/Ganeti/Storage/Lvm \
92         test/hs/Test/Ganeti/Confd \
93         test/hs/Test/Ganeti/HTools \
94         test/hs/Test/Ganeti/HTools/Backend \
95         test/hs/Test/Ganeti/Hypervisor \
96         test/hs/Test/Ganeti/Hypervisor/Xen \
97         test/hs/Test/Ganeti/Query
98
99 # Haskell directories without the roots (src, test/hs)
100 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
101
102 DIRS = \
103         $(HS_DIRS) \
104         autotools \
105         daemons \
106         devel \
107         devel/data \
108         doc \
109         doc/css \
110         doc/examples \
111         doc/examples/gnt-debug \
112         doc/examples/hooks \
113         test/data/htools \
114         test/data/htools/rapi \
115         test/hs/shelltests \
116         test/autotools \
117         lib \
118         lib/build \
119         lib/client \
120         lib/cmdlib \
121         lib/confd \
122         lib/http \
123         lib/hypervisor \
124         lib/impexpd \
125         lib/masterd \
126         lib/rapi \
127         lib/server \
128         lib/storage \
129         lib/tools \
130         lib/utils \
131         lib/watcher \
132         man \
133         qa \
134         test \
135         test/data \
136         test/data/bdev-rbd \
137         test/data/ovfdata \
138         test/data/ovfdata/other \
139         test/py \
140         tools
141
142 ALL_APIDOC_HS_DIRS = \
143         $(APIDOC_HS_DIR) \
144         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
145
146 BUILDTIME_DIR_AUTOCREATE = \
147         scripts \
148         $(APIDOC_DIR) \
149         $(ALL_APIDOC_HS_DIRS) \
150         $(APIDOC_PY_DIR) \
151         $(COVERAGE_DIR) \
152         $(COVERAGE_HS_DIR) \
153         $(COVERAGE_PY_DIR) \
154         .hpc
155
156 BUILDTIME_DIRS = \
157         $(BUILDTIME_DIR_AUTOCREATE) \
158         doc/html \
159         doc/man-html
160
161 DIRCHECK_EXCLUDE = \
162         $(BUILDTIME_DIRS) \
163         ganeti-[0-9]*.[0-9]*.[0-9]* \
164         doc/html/_* \
165         doc/man-html/_* \
166         autom4te.cache
167
168 # some helper vars
169 COVERAGE_DIR = doc/coverage
170 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
171 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
172 APIDOC_DIR = doc/api
173 APIDOC_PY_DIR = $(APIDOC_DIR)/py
174 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
175
176 MAINTAINERCLEANFILES = \
177         $(maninput) \
178         doc/install-quick.rst \
179         doc/news.rst \
180         doc/upgrade.rst \
181         vcs-version
182
183 maintainer-clean-local:
184         rm -rf $(BUILDTIME_DIRS)
185
186 CLEANFILES = \
187         $(addsuffix /*.py[co],$(DIRS)) \
188         $(addsuffix /*.hi,$(HS_DIRS)) \
189         $(addsuffix /*.o,$(HS_DIRS)) \
190         $(PYTHON_BOOTSTRAP) \
191         epydoc.conf \
192         $(REPLACE_VARS_SED) \
193         $(SHELL_ENV_INIT) \
194         daemons/daemon-util \
195         daemons/ganeti-cleaner \
196         devel/squeeze-amd64.tar.gz \
197         devel/squeeze-amd64.conf \
198         $(mandocrst) \
199         doc/manpages-enabled.rst \
200         $(BUILT_EXAMPLES) \
201         doc/examples/bash_completion \
202         doc/examples/bash_completion-debug \
203         lib/_generated_rpc.py \
204         $(man_MANS) \
205         $(manhtml) \
206         tools/kvm-ifup \
207         tools/vif-ganeti \
208         tools/net-common \
209         tools/users-setup \
210         tools/vcluster-setup \
211         stamp-directories \
212         stamp-srclinks \
213         $(nodist_pkgpython_PYTHON) \
214         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
215         $(HS_BUILT_TEST_HELPERS) \
216         src/ganeti-confd \
217         src/ganeti-luxid \
218         src/ganeti-mond \
219         .hpc/*.mix src/*.tix test/hs/*.tix \
220         doc/hs-lint.html
221
222 GENERATED_FILES = \
223         $(built_base_sources) \
224         $(BUILT_PYTHON_SOURCES) \
225         $(PYTHON_BOOTSTRAP)
226
227 HS_GENERATED_FILES =
228 if WANT_HTOOLS
229 HS_GENERATED_FILES += $(HS_PROGS)
230 if ENABLE_CONFD
231 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
232 endif
233
234 if ENABLE_MOND
235 HS_GENERATED_FILES += src/ganeti-mond
236 endif
237 endif
238
239 built_base_sources = \
240         stamp-directories \
241         stamp-srclinks
242
243 built_python_base_sources = \
244         lib/_autoconf.py \
245         lib/_vcsversion.py \
246         lib/opcodes.py
247
248 BUILT_PYTHON_SOURCES = \
249         $(built_python_base_sources) \
250         lib/_generated_rpc.py
251
252 # Generating the RPC wrappers depends on many things, so make sure
253 # it's built at the end of the built sources
254 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
255
256 # these are all built from the underlying %.in sources
257 BUILT_EXAMPLES = \
258         doc/examples/ganeti-kvm-poweroff.initd \
259         doc/examples/ganeti.cron \
260         doc/examples/ganeti.initd \
261         doc/examples/ganeti.logrotate \
262         doc/examples/ganeti-master-role.ocf \
263         doc/examples/ganeti-node-role.ocf \
264         doc/examples/gnt-config-backup \
265         doc/examples/hooks/ipsec
266
267 nodist_pkgpython_PYTHON = \
268         $(BUILT_PYTHON_SOURCES)
269
270 noinst_PYTHON = \
271         lib/build/__init__.py \
272         lib/build/shell_example_lexer.py \
273         lib/build/sphinx_ext.py
274
275 pkgpython_PYTHON = \
276         lib/__init__.py \
277         lib/asyncnotifier.py \
278         lib/backend.py \
279         lib/bootstrap.py \
280         lib/cli.py \
281         lib/compat.py \
282         lib/config.py \
283         lib/constants.py \
284         lib/daemon.py \
285         lib/errors.py \
286         lib/hooksmaster.py \
287         lib/ht.py \
288         lib/jqueue.py \
289         lib/jstore.py \
290         lib/locking.py \
291         lib/luxi.py \
292         lib/mcpu.py \
293         lib/netutils.py \
294         lib/objects.py \
295         lib/opcodes_base.py \
296         lib/outils.py \
297         lib/ovf.py \
298         lib/pathutils.py \
299         lib/qlang.py \
300         lib/query.py \
301         lib/rpc.py \
302         lib/rpc_defs.py \
303         lib/runtime.py \
304         lib/serializer.py \
305         lib/ssconf.py \
306         lib/ssh.py \
307         lib/uidpool.py \
308         lib/vcluster.py \
309         lib/network.py \
310         lib/workerpool.py
311
312 client_PYTHON = \
313         lib/client/__init__.py \
314         lib/client/gnt_backup.py \
315         lib/client/gnt_cluster.py \
316         lib/client/gnt_debug.py \
317         lib/client/gnt_group.py \
318         lib/client/gnt_instance.py \
319         lib/client/gnt_job.py \
320         lib/client/gnt_node.py \
321         lib/client/gnt_network.py \
322         lib/client/gnt_os.py \
323         lib/client/gnt_storage.py
324
325 cmdlib_PYTHON = \
326         lib/cmdlib/__init__.py \
327         lib/cmdlib/backup.py \
328         lib/cmdlib/base.py \
329         lib/cmdlib/cluster.py \
330         lib/cmdlib/common.py \
331         lib/cmdlib/group.py \
332         lib/cmdlib/instance.py \
333         lib/cmdlib/instance_migration.py \
334         lib/cmdlib/instance_operation.py \
335         lib/cmdlib/instance_query.py \
336         lib/cmdlib/instance_storage.py \
337         lib/cmdlib/instance_utils.py \
338         lib/cmdlib/misc.py \
339         lib/cmdlib/network.py \
340         lib/cmdlib/node.py \
341         lib/cmdlib/operating_system.py \
342         lib/cmdlib/query.py \
343         lib/cmdlib/tags.py \
344         lib/cmdlib/test.py
345
346 hypervisor_PYTHON = \
347         lib/hypervisor/__init__.py \
348         lib/hypervisor/hv_base.py \
349         lib/hypervisor/hv_chroot.py \
350         lib/hypervisor/hv_fake.py \
351         lib/hypervisor/hv_kvm.py \
352         lib/hypervisor/hv_lxc.py \
353         lib/hypervisor/hv_xen.py
354
355 storage_PYTHON = \
356         lib/storage/__init__.py \
357         lib/storage/bdev.py \
358         lib/storage/base.py \
359         lib/storage/container.py \
360         lib/storage/drbd.py \
361         lib/storage/drbd_info.py \
362         lib/storage/drbd_cmdgen.py \
363         lib/storage/filestorage.py
364
365 rapi_PYTHON = \
366         lib/rapi/__init__.py \
367         lib/rapi/baserlib.py \
368         lib/rapi/client.py \
369         lib/rapi/client_utils.py \
370         lib/rapi/connector.py \
371         lib/rapi/rlib2.py \
372         lib/rapi/testutils.py
373
374 http_PYTHON = \
375         lib/http/__init__.py \
376         lib/http/auth.py \
377         lib/http/client.py \
378         lib/http/server.py
379
380 confd_PYTHON = \
381         lib/confd/__init__.py \
382         lib/confd/client.py
383
384 masterd_PYTHON = \
385         lib/masterd/__init__.py \
386         lib/masterd/iallocator.py \
387         lib/masterd/instance.py
388
389 impexpd_PYTHON = \
390         lib/impexpd/__init__.py
391
392 watcher_PYTHON = \
393         lib/watcher/__init__.py \
394         lib/watcher/nodemaint.py \
395         lib/watcher/state.py
396
397 server_PYTHON = \
398         lib/server/__init__.py \
399         lib/server/masterd.py \
400         lib/server/noded.py \
401         lib/server/rapi.py
402
403 pytools_PYTHON = \
404         lib/tools/__init__.py \
405         lib/tools/burnin.py \
406         lib/tools/ensure_dirs.py \
407         lib/tools/node_cleanup.py \
408         lib/tools/node_daemon_setup.py \
409         lib/tools/prepare_node_join.py
410
411 utils_PYTHON = \
412         lib/utils/__init__.py \
413         lib/utils/algo.py \
414         lib/utils/filelock.py \
415         lib/utils/hash.py \
416         lib/utils/io.py \
417         lib/utils/log.py \
418         lib/utils/lvm.py \
419         lib/utils/mlock.py \
420         lib/utils/nodesetup.py \
421         lib/utils/process.py \
422         lib/utils/retry.py \
423         lib/utils/storage.py \
424         lib/utils/text.py \
425         lib/utils/wrapper.py \
426         lib/utils/x509.py
427
428 docinput = \
429         doc/conf.py \
430         doc/css/style.css \
431         doc/admin.rst \
432         doc/cluster-merge.rst \
433         doc/design-2.0.rst \
434         doc/design-2.1.rst \
435         doc/design-2.2.rst \
436         doc/design-2.3.rst \
437         doc/design-2.4.rst \
438         doc/design-2.5.rst \
439         doc/design-2.6.rst \
440         doc/design-2.7.rst \
441         doc/design-2.8.rst \
442         doc/design-autorepair.rst \
443         doc/design-bulk-create.rst \
444         doc/design-chained-jobs.rst \
445         doc/design-cpu-pinning.rst \
446         doc/design-device-uuid-name.rst \
447         doc/design-draft.rst \
448         doc/design-hotplug.rst \
449         doc/design-htools-2.3.rst \
450         doc/design-http-server.rst \
451         doc/design-impexp2.rst \
452         doc/design-internal-shutdown.rst \
453         doc/design-lu-generated-jobs.rst \
454         doc/design-linuxha.rst \
455         doc/design-multi-reloc.rst \
456         doc/design-network.rst \
457         doc/design-node-add.rst \
458         doc/design-oob.rst \
459         doc/design-ovf-support.rst \
460         doc/design-opportunistic-locking.rst \
461         doc/design-optables.rst \
462         doc/design-partitioned.rst \
463         doc/design-query-splitting.rst \
464         doc/design-query2.rst \
465         doc/design-reason-trail.rst \
466         doc/design-resource-model.rst \
467         doc/design-restricted-commands.rst \
468         doc/design-shared-storage.rst \
469         doc/design-monitoring-agent.rst \
470         doc/design-virtual-clusters.rst \
471         doc/design-x509-ca.rst \
472         doc/design-hroller.rst \
473         doc/design-storagetypes.rst \
474         doc/devnotes.rst \
475         doc/glossary.rst \
476         doc/hooks.rst \
477         doc/iallocator.rst \
478         doc/index.rst \
479         doc/install-quick.rst \
480         doc/install.rst \
481         doc/locking.rst \
482         doc/manpages-disabled.rst \
483         doc/monitoring-query-format.rst \
484         doc/move-instance.rst \
485         doc/news.rst \
486         doc/ovfconverter.rst \
487         doc/rapi.rst \
488         doc/security.rst \
489         doc/upgrade.rst \
490         doc/virtual-cluster.rst \
491         doc/walkthrough.rst
492
493 # Generates file names such as "doc/man-gnt-instance.rst"
494 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
495
496 # Haskell programs to be installed in $PREFIX/bin
497 HS_BIN_PROGS=src/htools
498
499 # Haskell programs to be installed in the MYEXECLIB dir
500 if ENABLE_MOND
501 HS_MYEXECLIB_PROGS=src/mon-collector
502 else
503 HS_MYEXECLIB_PROGS=
504 endif
505
506 # Haskell programs to be compiled by "make really-all"
507 HS_COMPILE_PROGS= \
508         src/ganeti-mond \
509         src/hconfd \
510         src/hluxid \
511         src/hs2py \
512         src/rpc-test
513
514 # All Haskell non-test programs to be compiled but not automatically installed
515 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
516
517 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
518 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
519
520 HS_ALL_PROGS = \
521         $(HS_PROGS) \
522         test/hs/hpc-htools \
523         test/hs/hpc-mon-collector \
524         test/hs/htest \
525         $(HS_COMPILE_PROGS)
526
527 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
528 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
529
530 HFLAGS = \
531         -O -Wall -Werror -isrc \
532         -fwarn-monomorphism-restriction \
533         -fwarn-tabs \
534         $(GHC_BYVERSION_FLAGS)
535
536 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
537 HEXTRA =
538 # internal extra flags (used for test/hs/htest mainly)
539 HEXTRA_INT =
540 # exclude options for coverage reports
541 HPCEXCL = --exclude Main \
542         --exclude Ganeti.Constants \
543         --exclude Ganeti.HTools.QC \
544         --exclude Ganeti.THH \
545         --exclude Ganeti.Version \
546         --exclude Test.Ganeti.Attoparsec \
547         --exclude Test.Ganeti.TestCommon \
548         --exclude Test.Ganeti.TestHTools \
549         --exclude Test.Ganeti.TestHelper \
550         --exclude Test.Ganeti.TestImports \
551         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
552
553 HS_LIB_SRCS = \
554         src/Ganeti/BasicTypes.hs \
555         src/Ganeti/Common.hs \
556         src/Ganeti/Compat.hs \
557         src/Ganeti/Confd/Client.hs \
558         src/Ganeti/Confd/ClientFunctions.hs \
559         src/Ganeti/Confd/Server.hs \
560         src/Ganeti/Confd/Types.hs \
561         src/Ganeti/Confd/Utils.hs \
562         src/Ganeti/Config.hs \
563         src/Ganeti/ConfigReader.hs \
564         src/Ganeti/Cpu/LoadParser.hs \
565         src/Ganeti/Cpu/Types.hs \
566         src/Ganeti/Curl/Multi.hs \
567         src/Ganeti/Daemon.hs \
568         src/Ganeti/DataCollectors/CLI.hs \
569         src/Ganeti/DataCollectors/CPUload.hs \
570         src/Ganeti/DataCollectors/Diskstats.hs \
571         src/Ganeti/DataCollectors/Drbd.hs \
572         src/Ganeti/DataCollectors/InstStatus.hs \
573         src/Ganeti/DataCollectors/InstStatusTypes.hs \
574         src/Ganeti/DataCollectors/Lv.hs \
575         src/Ganeti/DataCollectors/Program.hs \
576         src/Ganeti/DataCollectors/Types.hs \
577         src/Ganeti/Errors.hs \
578         src/Ganeti/HTools/Backend/IAlloc.hs \
579         src/Ganeti/HTools/Backend/Luxi.hs \
580         src/Ganeti/HTools/Backend/Rapi.hs \
581         src/Ganeti/HTools/Backend/Simu.hs \
582         src/Ganeti/HTools/Backend/Text.hs \
583         src/Ganeti/HTools/CLI.hs \
584         src/Ganeti/HTools/Cluster.hs \
585         src/Ganeti/HTools/Container.hs \
586         src/Ganeti/HTools/ExtLoader.hs \
587         src/Ganeti/HTools/Graph.hs \
588         src/Ganeti/HTools/Group.hs \
589         src/Ganeti/HTools/Instance.hs \
590         src/Ganeti/HTools/Loader.hs \
591         src/Ganeti/HTools/Nic.hs \
592         src/Ganeti/HTools/Node.hs \
593         src/Ganeti/HTools/PeerMap.hs \
594         src/Ganeti/HTools/Program/Hail.hs \
595         src/Ganeti/HTools/Program/Harep.hs \
596         src/Ganeti/HTools/Program/Hbal.hs \
597         src/Ganeti/HTools/Program/Hcheck.hs \
598         src/Ganeti/HTools/Program/Hinfo.hs \
599         src/Ganeti/HTools/Program/Hscan.hs \
600         src/Ganeti/HTools/Program/Hspace.hs \
601         src/Ganeti/HTools/Program/Hroller.hs \
602         src/Ganeti/HTools/Program/Main.hs \
603         src/Ganeti/HTools/Types.hs \
604         src/Ganeti/Hypervisor/Xen.hs \
605         src/Ganeti/Hypervisor/Xen/XmParser.hs \
606         src/Ganeti/Hypervisor/Xen/Types.hs \
607         src/Ganeti/Hash.hs \
608         src/Ganeti/Hs2Py/GenOpCodes.hs \
609         src/Ganeti/Hs2Py/OpDoc.hs \
610         src/Ganeti/JQueue.hs \
611         src/Ganeti/JSON.hs \
612         src/Ganeti/Jobs.hs \
613         src/Ganeti/Logging.hs \
614         src/Ganeti/Luxi.hs \
615         src/Ganeti/Monitoring/Server.hs \
616         src/Ganeti/Network.hs \
617         src/Ganeti/Objects.hs \
618         src/Ganeti/OpCodes.hs \
619         src/Ganeti/OpParams.hs \
620         src/Ganeti/Path.hs \
621         src/Ganeti/Parsers.hs \
622         src/Ganeti/Query/Cluster.hs \
623         src/Ganeti/Query/Common.hs \
624         src/Ganeti/Query/Export.hs \
625         src/Ganeti/Query/Filter.hs \
626         src/Ganeti/Query/Group.hs \
627         src/Ganeti/Query/Job.hs \
628         src/Ganeti/Query/Language.hs \
629         src/Ganeti/Query/Network.hs \
630         src/Ganeti/Query/Node.hs \
631         src/Ganeti/Query/Query.hs \
632         src/Ganeti/Query/Server.hs \
633         src/Ganeti/Query/Types.hs \
634         src/Ganeti/Rpc.hs \
635         src/Ganeti/Runtime.hs \
636         src/Ganeti/Ssconf.hs \
637         src/Ganeti/Storage/Diskstats/Parser.hs \
638         src/Ganeti/Storage/Diskstats/Types.hs \
639         src/Ganeti/Storage/Drbd/Parser.hs \
640         src/Ganeti/Storage/Drbd/Types.hs \
641         src/Ganeti/Storage/Lvm/LVParser.hs \
642         src/Ganeti/Storage/Lvm/Types.hs \
643         src/Ganeti/Storage/Utils.hs \
644         src/Ganeti/THH.hs \
645         src/Ganeti/Types.hs \
646         src/Ganeti/Utils.hs
647
648 HS_TEST_SRCS = \
649         test/hs/Test/Ganeti/Attoparsec.hs \
650         test/hs/Test/Ganeti/BasicTypes.hs \
651         test/hs/Test/Ganeti/Common.hs \
652         test/hs/Test/Ganeti/Confd/Types.hs \
653         test/hs/Test/Ganeti/Confd/Utils.hs \
654         test/hs/Test/Ganeti/Daemon.hs \
655         test/hs/Test/Ganeti/Errors.hs \
656         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
657         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
658         test/hs/Test/Ganeti/HTools/CLI.hs \
659         test/hs/Test/Ganeti/HTools/Cluster.hs \
660         test/hs/Test/Ganeti/HTools/Container.hs \
661         test/hs/Test/Ganeti/HTools/Graph.hs \
662         test/hs/Test/Ganeti/HTools/Instance.hs \
663         test/hs/Test/Ganeti/HTools/Loader.hs \
664         test/hs/Test/Ganeti/HTools/Node.hs \
665         test/hs/Test/Ganeti/HTools/PeerMap.hs \
666         test/hs/Test/Ganeti/HTools/Types.hs \
667         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
668         test/hs/Test/Ganeti/JSON.hs \
669         test/hs/Test/Ganeti/Jobs.hs \
670         test/hs/Test/Ganeti/JQueue.hs \
671         test/hs/Test/Ganeti/Luxi.hs \
672         test/hs/Test/Ganeti/Network.hs \
673         test/hs/Test/Ganeti/Objects.hs \
674         test/hs/Test/Ganeti/OpCodes.hs \
675         test/hs/Test/Ganeti/Query/Filter.hs \
676         test/hs/Test/Ganeti/Query/Language.hs \
677         test/hs/Test/Ganeti/Query/Network.hs \
678         test/hs/Test/Ganeti/Query/Query.hs \
679         test/hs/Test/Ganeti/Rpc.hs \
680         test/hs/Test/Ganeti/Runtime.hs \
681         test/hs/Test/Ganeti/Ssconf.hs \
682         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
683         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
684         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
685         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
686         test/hs/Test/Ganeti/THH.hs \
687         test/hs/Test/Ganeti/TestCommon.hs \
688         test/hs/Test/Ganeti/TestHTools.hs \
689         test/hs/Test/Ganeti/TestHelper.hs \
690         test/hs/Test/Ganeti/Types.hs \
691         test/hs/Test/Ganeti/Utils.hs
692
693 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
694
695 HS_BUILT_SRCS = \
696         test/hs/Test/Ganeti/TestImports.hs \
697         src/Ganeti/Constants.hs \
698         src/Ganeti/Curl/Internal.hs \
699         src/Ganeti/Version.hs
700 HS_BUILT_SRCS_IN = \
701         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
702         src/Ganeti/Curl/Internal.hsc \
703         lib/opcodes.py.in_after \
704         lib/opcodes.py.in_before
705
706 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
707
708 $(RUN_IN_TEMPDIR): | stamp-directories
709
710 doc/html/index.html: ENABLE_MANPAGES =
711 doc/man-html/index.html: ENABLE_MANPAGES = 1
712 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
713
714 # Note: we use here an order-only prerequisite, as the contents of
715 # _autoconf.py are not actually influencing the html build output: it
716 # has to exist in order for the sphinx module to be loaded
717 # successfully, but we certainly don't want the docs to be rebuilt if
718 # it changes
719 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
720         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
721         lib/build/shell_example_lexer.py lib/ht.py \
722         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
723         autotools/sphinx-wrapper | $(BUILT_PYTHON_SOURCES)
724         @test -n "$(SPHINX)" || \
725             { echo 'sphinx-build' not found during configure; exit 1; }
726 if !MANPAGES_IN_DOC
727         if test -n '$(ENABLE_MANPAGES)'; then \
728           echo 'Man pages in documentation were disabled at configure time' >&2; \
729           exit 1; \
730         fi
731 endif
732 ## Sphinx provides little control over what content should be included. Some
733 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
734 ## build two different versions of the documentation--once without man pages and
735 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
736 ## us with this, but requires running in a temporary directory. It moves the
737 ## correct files into place depending on environment variables.
738         dir=$(dir $@) && \
739         @mkdir_p@ $$dir && \
740         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
741         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
742             -d . \
743             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
744             -D release="$(PACKAGE_VERSION)" \
745             -D graphviz_dot="$(DOT)" \
746             -D enable_manpages="$(ENABLE_MANPAGES)" \
747             doc $(CURDIR)/$$dir && \
748         rm -f $$dir/.buildinfo $$dir/objects.inv
749         touch $@
750
751 doc/html: doc/html/index.html
752
753 doc/man-html: doc/man-html/index.html
754
755 doc/install-quick.rst: INSTALL
756 doc/news.rst: NEWS
757 doc/upgrade.rst: UPGRADE
758
759 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
760         set -e; \
761         { echo '.. This file is automatically updated at build time from $<.'; \
762           echo '.. Do not edit.'; \
763           echo; \
764           cat $<; \
765         } > $@
766
767 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
768         { echo '.. This file is automatically generated, do not edit!'; \
769           echo ''; \
770           echo 'Man pages'; \
771           echo '========='; \
772           echo; \
773           echo '.. toctree::'; \
774           echo '   :maxdepth: 1'; \
775           echo; \
776           for i in $(notdir $(mandocrst)); do \
777             echo "   $$i"; \
778           done | LC_ALL=C sort; \
779         } > $@
780
781 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
782 if MANPAGES_IN_DOC
783         { echo '.. This file is automatically updated at build time from $<.'; \
784           echo '.. Do not edit.'; \
785           echo; \
786           echo "$*"; \
787           echo '=========================================='; \
788           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
789         } > $@
790 else
791         echo 'Man pages in documentation were disabled at configure time' >&2; \
792         exit 1;
793 endif
794
795 # Things to build but not to install (add it to EXTRA_DIST if it should be
796 # distributed)
797 noinst_DATA = \
798         $(BUILT_EXAMPLES) \
799         doc/examples/bash_completion \
800         doc/examples/bash_completion-debug \
801         $(manhtml)
802
803 if HAS_SPHINX
804 if MANPAGES_IN_DOC
805 noinst_DATA += doc/man-html
806 else
807 noinst_DATA += doc/html
808 endif
809 endif
810
811 gnt_scripts = \
812         scripts/gnt-backup \
813         scripts/gnt-cluster \
814         scripts/gnt-debug \
815         scripts/gnt-group \
816         scripts/gnt-instance \
817         scripts/gnt-job \
818         scripts/gnt-network \
819         scripts/gnt-node \
820         scripts/gnt-os \
821         scripts/gnt-storage
822
823 PYTHON_BOOTSTRAP_SBIN = \
824         daemons/ganeti-masterd \
825         daemons/ganeti-noded \
826         daemons/ganeti-rapi \
827         daemons/ganeti-watcher \
828         $(gnt_scripts)
829
830 PYTHON_BOOTSTRAP = \
831         $(PYTHON_BOOTSTRAP_SBIN) \
832         tools/burnin \
833         tools/ensure-dirs \
834         tools/node-cleanup \
835         tools/node-daemon-setup \
836         tools/prepare-node-join
837
838 qa_scripts = \
839         qa/__init__.py \
840         qa/ganeti-qa.py \
841         qa/qa_cluster.py \
842         qa/qa_config.py \
843         qa/qa_daemon.py \
844         qa/qa_env.py \
845         qa/qa_error.py \
846         qa/qa_group.py \
847         qa/qa_instance.py \
848         qa/qa_instance_utils.py \
849         qa/qa_job.py \
850         qa/qa_monitoring.py \
851         qa/qa_node.py \
852         qa/qa_os.py \
853         qa/qa_rapi.py \
854         qa/qa_tags.py \
855         qa/qa_utils.py
856
857 bin_SCRIPTS =
858 if WANT_HTOOLS
859 bin_SCRIPTS += $(HS_BIN_PROGS)
860 install-exec-hook:
861         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
862 # FIXME: this is a hardcoded logic, instead of auto-resolving
863         $(LN_S) -f ../../../bin/htools \
864           $(DESTDIR)$(iallocatorsdir)/hail
865         for role in $(HS_BIN_ROLES); do \
866           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
867         done
868 endif
869
870 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
871         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
872           echo "Error: cannot run unittests without the development" \
873                " libraries (see devnotes.rst)" 1>&2; \
874           exit 1; \
875         fi
876         @rm -f $(notdir $@).tix
877         $(GHC) --make \
878           $(HFLAGS) \
879           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
880           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
881           $(HEXTRA) $(HEXTRA_INT) $@
882         @touch "$@"
883
884 # for the test/hs/htest binary, we need to enable profiling/coverage
885 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
886
887 # we compile the hpc-htools binary with the program coverage
888 test/hs/hpc-htools: HEXTRA_INT=-fhpc
889
890 # we compile the hpc-mon-collector binary with the program coverage
891 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
892
893 # test dependency
894 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
895
896 # rules for building profiling-enabled versions of the haskell
897 # programs: hs-prof does the full two-step build, whereas
898 # hs-prof-quick does only the final rebuild (hs-prof must have been
899 # run before)
900 .PHONY: hs-prof hs-prof-quick
901 hs-prof:
902         @if [ -z "$(TARGET)" ]; then \
903           echo "You need to define TARGET when running this rule" 1>&2; \
904           exit 1; \
905         fi
906         $(MAKE) $(AM_MAKEFLAGS) clean
907         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
908         rm -f $(HS_ALL_PROGS)
909         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
910
911 hs-prof-quick:
912         @if [ -z "$(TARGET)" ]; then \
913           echo "You need to define TARGET when running this rule" 1>&2; \
914           exit 1; \
915         fi
916         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
917
918 dist_sbin_SCRIPTS = \
919         tools/ganeti-listrunner
920
921 nodist_sbin_SCRIPTS = \
922         $(PYTHON_BOOTSTRAP_SBIN) \
923         daemons/ganeti-cleaner
924
925 if ENABLE_CONFD
926 src/ganeti-confd: src/hconfd
927         cp -f $< $@
928
929 src/ganeti-luxid: src/hluxid
930         cp -f $< $@
931
932 nodist_sbin_SCRIPTS += src/ganeti-confd
933 nodist_sbin_SCRIPTS += src/ganeti-luxid
934 endif
935
936 if ENABLE_MOND
937 nodist_sbin_SCRIPTS += src/ganeti-mond
938 endif
939
940 python_scripts = \
941         tools/cfgshell \
942         tools/cfgupgrade \
943         tools/cfgupgrade12 \
944         tools/cluster-merge \
945         tools/confd-client \
946         tools/fmtjson \
947         tools/lvmstrap \
948         tools/move-instance \
949         tools/ovfconverter \
950         tools/sanitize-config
951
952 dist_tools_SCRIPTS = \
953         $(python_scripts) \
954         tools/burnin \
955         tools/kvm-console-wrapper \
956         tools/master-ip-setup \
957         tools/xen-console-wrapper
958
959 nodist_tools_python_scripts = \
960         tools/node-cleanup
961
962 nodist_tools_SCRIPTS = \
963         $(nodist_tools_python_scripts) \
964         tools/users-setup \
965         tools/vcluster-setup
966
967 pkglib_python_scripts = \
968         daemons/import-export \
969         tools/check-cert-expired
970
971 nodist_pkglib_python_scripts = \
972         tools/ensure-dirs \
973         tools/node-daemon-setup \
974         tools/prepare-node-join
975
976 myexeclib_SCRIPTS = \
977         daemons/daemon-util \
978         tools/kvm-ifup \
979         tools/vif-ganeti \
980         tools/net-common \
981         $(pkglib_python_scripts) \
982         $(HS_MYEXECLIB_PROGS)
983
984 nodist_myexeclib_SCRIPTS = \
985         $(nodist_pkglib_python_scripts)
986
987 EXTRA_DIST = \
988         NEWS \
989         UPGRADE \
990         epydoc.conf.in \
991         pylintrc \
992         autotools/build-bash-completion \
993         autotools/build-rpc \
994         autotools/check-header \
995         autotools/check-imports \
996         autotools/check-man-dashes \
997         autotools/check-man-references \
998         autotools/check-man-warnings \
999         autotools/check-news \
1000         autotools/check-python-code \
1001         autotools/check-tar \
1002         autotools/check-version \
1003         autotools/convert-constants \
1004         autotools/docpp \
1005         autotools/gen-py-coverage \
1006         autotools/sphinx-wrapper \
1007         autotools/testrunner \
1008         autotools/wrong-hardcoded-paths \
1009         $(RUN_IN_TEMPDIR) \
1010         daemons/daemon-util.in \
1011         daemons/ganeti-cleaner.in \
1012         $(pkglib_python_scripts) \
1013         devel/upload \
1014         devel/webserver \
1015         tools/kvm-ifup.in \
1016         tools/vif-ganeti.in \
1017         tools/net-common.in \
1018         tools/users-setup.in \
1019         tools/vcluster-setup.in \
1020         $(docinput) \
1021         doc/html \
1022         $(BUILT_EXAMPLES:%=%.in) \
1023         doc/examples/ganeti.default \
1024         doc/examples/ganeti.default-debug \
1025         doc/examples/hooks/ethers \
1026         doc/examples/gnt-debug/README \
1027         doc/examples/gnt-debug/delay0.json \
1028         doc/examples/gnt-debug/delay50.json \
1029         test/py/lockperf.py \
1030         test/py/testutils.py \
1031         test/py/mocks.py \
1032         $(dist_TESTS) \
1033         $(TEST_FILES) \
1034         man/footer.rst \
1035         $(manrst) \
1036         $(maninput) \
1037         qa/qa-sample.json \
1038         $(qa_scripts) \
1039         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1040         $(HS_PROG_SRCS) \
1041         src/lint-hints.hs \
1042         test/hs/cli-tests-defs.sh \
1043         test/hs/offline-test.sh \
1044         .ghci
1045
1046 man_MANS = \
1047         man/ganeti-cleaner.8 \
1048         man/ganeti-confd.8 \
1049         man/ganeti-luxid.8 \
1050         man/ganeti-listrunner.8 \
1051         man/ganeti-masterd.8 \
1052         man/ganeti-mond.8 \
1053         man/ganeti-noded.8 \
1054         man/ganeti-os-interface.7 \
1055         man/ganeti-extstorage-interface.7 \
1056         man/ganeti-rapi.8 \
1057         man/ganeti-watcher.8 \
1058         man/ganeti.7 \
1059         man/gnt-backup.8 \
1060         man/gnt-cluster.8 \
1061         man/gnt-debug.8 \
1062         man/gnt-group.8 \
1063         man/gnt-network.8 \
1064         man/gnt-instance.8 \
1065         man/gnt-job.8 \
1066         man/gnt-node.8 \
1067         man/gnt-os.8 \
1068         man/gnt-storage.8 \
1069         man/hail.1 \
1070         man/harep.1 \
1071         man/hbal.1 \
1072         man/hcheck.1 \
1073         man/hinfo.1 \
1074         man/hscan.1 \
1075         man/hspace.1 \
1076         man/hroller.1 \
1077         man/htools.1 \
1078         man/mon-collector.7
1079
1080 # Remove extensions from all filenames in man_MANS
1081 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1082
1083 manrst = $(patsubst %,%.rst,$(mannoext))
1084 manhtml = $(patsubst %.rst,%.html,$(manrst))
1085 mangen = $(patsubst %.rst,%.gen,$(manrst))
1086 maninput = \
1087         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1088         $(patsubst %.html,%.html.in,$(manhtml)) \
1089         $(mangen)
1090
1091 TEST_FILES = \
1092         test/autotools/autotools-check-news.test \
1093         test/data/htools/clean-nonzero-score.data \
1094         test/data/htools/common-suffix.data \
1095         test/data/htools/empty-cluster.data \
1096         test/data/htools/hail-alloc-drbd.json \
1097         test/data/htools/hail-alloc-invalid-network.json \
1098         test/data/htools/hail-alloc-invalid-twodisks.json \
1099         test/data/htools/hail-alloc-restricted-network.json \
1100         test/data/htools/hail-alloc-spindles.json \
1101         test/data/htools/hail-alloc-twodisks.json \
1102         test/data/htools/hail-change-group.json \
1103         test/data/htools/hail-invalid-reloc.json \
1104         test/data/htools/hail-node-evac.json \
1105         test/data/htools/hail-reloc-drbd.json \
1106         test/data/htools/hbal-excl-tags.data \
1107         test/data/htools/hbal-split-insts.data \
1108         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1109         test/data/htools/hspace-tiered-dualspec.data \
1110         test/data/htools/hspace-tiered-exclusive.data \
1111         test/data/htools/hspace-tiered-ipolicy.data \
1112         test/data/htools/hspace-tiered-mixed.data \
1113         test/data/htools/hspace-tiered-resourcetypes.data \
1114         test/data/htools/hspace-tiered-vcpu.data \
1115         test/data/htools/hspace-tiered.data \
1116         test/data/htools/invalid-node.data \
1117         test/data/htools/missing-resources.data \
1118         test/data/htools/multiple-master.data \
1119         test/data/htools/multiple-tags.data \
1120         test/data/htools/n1-failure.data \
1121         test/data/htools/rapi/groups.json \
1122         test/data/htools/rapi/info.json \
1123         test/data/htools/rapi/instances.json \
1124         test/data/htools/rapi/nodes.json \
1125         test/data/htools/hroller-full.data \
1126         test/data/htools/hroller-nodegroups.data \
1127         test/data/htools/hroller-nonredundant.data \
1128         test/data/htools/hroller-online.data \
1129         test/data/htools/unique-reboot-order.data \
1130         test/hs/shelltests/htools-balancing.test \
1131         test/hs/shelltests/htools-basic.test \
1132         test/hs/shelltests/htools-dynutil.test \
1133         test/hs/shelltests/htools-excl.test \
1134         test/hs/shelltests/htools-hail.test \
1135         test/hs/shelltests/htools-hroller.test \
1136         test/hs/shelltests/htools-hspace.test \
1137         test/hs/shelltests/htools-invalid.test \
1138         test/hs/shelltests/htools-multi-group.test \
1139         test/hs/shelltests/htools-no-backend.test \
1140         test/hs/shelltests/htools-rapi.test \
1141         test/hs/shelltests/htools-single-group.test \
1142         test/hs/shelltests/htools-text-backend.test \
1143         test/hs/shelltests/htools-mon-collector.test \
1144         test/data/bdev-drbd-8.0.txt \
1145         test/data/bdev-drbd-8.3.txt \
1146         test/data/bdev-drbd-8.4.txt \
1147         test/data/bdev-drbd-8.4-no-disk-params.txt \
1148         test/data/bdev-drbd-disk.txt \
1149         test/data/bdev-drbd-net-ip4.txt \
1150         test/data/bdev-drbd-net-ip6.txt \
1151         test/data/bdev-rbd/json_output_empty.txt \
1152         test/data/bdev-rbd/json_output_extra_matches.txt \
1153         test/data/bdev-rbd/json_output_no_matches.txt \
1154         test/data/bdev-rbd/json_output_ok.txt \
1155         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1156         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1157         test/data/bdev-rbd/plain_output_new_ok.txt \
1158         test/data/bdev-rbd/plain_output_old_empty.txt \
1159         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1160         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1161         test/data/bdev-rbd/plain_output_old_ok.txt \
1162         test/data/bdev-rbd/output_invalid.txt \
1163         test/data/cert1.pem \
1164         test/data/cert2.pem \
1165         test/data/cluster_config_2.7.json \
1166         test/data/cluster_config_2.8.json \
1167         test/data/cluster_config_2.9.json \
1168         test/data/instance-minor-pairing.txt \
1169         test/data/instance-prim-sec.txt \
1170         test/data/ip-addr-show-dummy0.txt \
1171         test/data/ip-addr-show-lo-ipv4.txt \
1172         test/data/ip-addr-show-lo-ipv6.txt \
1173         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1174         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1175         test/data/ip-addr-show-lo-oneline.txt \
1176         test/data/ip-addr-show-lo.txt \
1177         test/data/kvm_0.12.5_help.txt \
1178         test/data/kvm_0.15.90_help.txt \
1179         test/data/kvm_0.9.1_help.txt \
1180         test/data/kvm_0.9.1_help_boot_test.txt \
1181         test/data/kvm_1.0_help.txt \
1182         test/data/kvm_1.1.2_help.txt \
1183         test/data/lvs_lv.txt \
1184         test/data/NEWS_OK.txt \
1185         test/data/NEWS_previous_unreleased.txt \
1186         test/data/ovfdata/compr_disk.vmdk.gz \
1187         test/data/ovfdata/config.ini \
1188         test/data/ovfdata/corrupted_resources.ovf \
1189         test/data/ovfdata/empty.ini \
1190         test/data/ovfdata/empty.ovf \
1191         test/data/ovfdata/ganeti.mf \
1192         test/data/ovfdata/ganeti.ovf \
1193         test/data/ovfdata/gzip_disk.ovf \
1194         test/data/ovfdata/new_disk.vmdk \
1195         test/data/ovfdata/no_disk.ini \
1196         test/data/ovfdata/no_disk_in_ref.ovf \
1197         test/data/ovfdata/no_os.ini \
1198         test/data/ovfdata/no_ovf.ova \
1199         test/data/ovfdata/other/rawdisk.raw \
1200         test/data/ovfdata/ova.ova \
1201         test/data/ovfdata/rawdisk.raw \
1202         test/data/ovfdata/second_disk.vmdk \
1203         test/data/ovfdata/unsafe_path.ini \
1204         test/data/ovfdata/virtualbox.ovf \
1205         test/data/ovfdata/wrong_config.ini \
1206         test/data/ovfdata/wrong_extension.ovd \
1207         test/data/ovfdata/wrong_manifest.mf \
1208         test/data/ovfdata/wrong_manifest.ovf \
1209         test/data/ovfdata/wrong_ova.ova \
1210         test/data/ovfdata/wrong_xml.ovf \
1211         test/data/proc_diskstats.txt \
1212         test/data/proc_drbd8.txt \
1213         test/data/proc_drbd80-emptyline.txt \
1214         test/data/proc_drbd80-emptyversion.txt \
1215         test/data/proc_drbd83.txt \
1216         test/data/proc_drbd83_sync.txt \
1217         test/data/proc_drbd83_sync_want.txt \
1218         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1219         test/data/proc_drbd84.txt \
1220         test/data/proc_drbd84_sync.txt \
1221         test/data/qa-minimal-nodes-instances-only.json \
1222         test/data/sys_drbd_usermode_helper.txt \
1223         test/data/vgreduce-removemissing-2.02.02.txt \
1224         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1225         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1226         test/data/vgs-missing-pvs-2.02.02.txt \
1227         test/data/vgs-missing-pvs-2.02.66.txt \
1228         test/data/xen-xm-info-4.0.1.txt \
1229         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1230         test/data/xen-xm-list-4.0.1-four-instances.txt \
1231         test/data/xen-xm-list-long-4.0.1.txt \
1232         test/data/xen-xm-uptime-4.0.1.txt \
1233         test/py/ganeti-cli.test \
1234         test/py/gnt-cli.test \
1235         test/py/import-export_unittest-helper
1236
1237
1238 python_tests = \
1239         doc/examples/rapi_testutils.py \
1240         test/py/cfgupgrade_unittest.py \
1241         test/py/docs_unittest.py \
1242         test/py/ganeti.asyncnotifier_unittest.py \
1243         test/py/ganeti.backend_unittest-runasroot.py \
1244         test/py/ganeti.backend_unittest.py \
1245         test/py/ganeti.bootstrap_unittest.py \
1246         test/py/ganeti.cli_unittest.py \
1247         test/py/ganeti.client.gnt_cluster_unittest.py \
1248         test/py/ganeti.client.gnt_instance_unittest.py \
1249         test/py/ganeti.client.gnt_job_unittest.py \
1250         test/py/ganeti.cmdlib_unittest.py \
1251         test/py/ganeti.cmdlib.cluster_unittest.py \
1252         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1253         test/py/ganeti.compat_unittest.py \
1254         test/py/ganeti.confd.client_unittest.py \
1255         test/py/ganeti.config_unittest.py \
1256         test/py/ganeti.constants_unittest.py \
1257         test/py/ganeti.daemon_unittest.py \
1258         test/py/ganeti.errors_unittest.py \
1259         test/py/ganeti.hooks_unittest.py \
1260         test/py/ganeti.ht_unittest.py \
1261         test/py/ganeti.http_unittest.py \
1262         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1263         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1264         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1265         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1266         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1267         test/py/ganeti.hypervisor_unittest.py \
1268         test/py/ganeti.impexpd_unittest.py \
1269         test/py/ganeti.jqueue_unittest.py \
1270         test/py/ganeti.jstore_unittest.py \
1271         test/py/ganeti.locking_unittest.py \
1272         test/py/ganeti.luxi_unittest.py \
1273         test/py/ganeti.masterd.iallocator_unittest.py \
1274         test/py/ganeti.masterd.instance_unittest.py \
1275         test/py/ganeti.mcpu_unittest.py \
1276         test/py/ganeti.netutils_unittest.py \
1277         test/py/ganeti.objects_unittest.py \
1278         test/py/ganeti.opcodes_unittest.py \
1279         test/py/ganeti.outils_unittest.py \
1280         test/py/ganeti.ovf_unittest.py \
1281         test/py/ganeti.qlang_unittest.py \
1282         test/py/ganeti.query_unittest.py \
1283         test/py/ganeti.rapi.baserlib_unittest.py \
1284         test/py/ganeti.rapi.client_unittest.py \
1285         test/py/ganeti.rapi.resources_unittest.py \
1286         test/py/ganeti.rapi.rlib2_unittest.py \
1287         test/py/ganeti.rapi.testutils_unittest.py \
1288         test/py/ganeti.rpc_unittest.py \
1289         test/py/ganeti.runtime_unittest.py \
1290         test/py/ganeti.serializer_unittest.py \
1291         test/py/ganeti.server.rapi_unittest.py \
1292         test/py/ganeti.ssconf_unittest.py \
1293         test/py/ganeti.ssh_unittest.py \
1294         test/py/ganeti.storage.bdev_unittest.py \
1295         test/py/ganeti.storage.container_unittest.py \
1296         test/py/ganeti.storage.drbd_unittest.py \
1297         test/py/ganeti.storage.filestorage_unittest.py \
1298         test/py/ganeti.tools.burnin_unittest.py \
1299         test/py/ganeti.tools.ensure_dirs_unittest.py \
1300         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1301         test/py/ganeti.tools.prepare_node_join_unittest.py \
1302         test/py/ganeti.uidpool_unittest.py \
1303         test/py/ganeti.utils.algo_unittest.py \
1304         test/py/ganeti.utils.filelock_unittest.py \
1305         test/py/ganeti.utils.hash_unittest.py \
1306         test/py/ganeti.utils.io_unittest-runasroot.py \
1307         test/py/ganeti.utils.io_unittest.py \
1308         test/py/ganeti.utils.log_unittest.py \
1309         test/py/ganeti.utils.lvm_unittest.py \
1310         test/py/ganeti.utils.mlock_unittest.py \
1311         test/py/ganeti.utils.nodesetup_unittest.py \
1312         test/py/ganeti.utils.process_unittest.py \
1313         test/py/ganeti.utils.retry_unittest.py \
1314         test/py/ganeti.utils.storage_unittest.py \
1315         test/py/ganeti.utils.text_unittest.py \
1316         test/py/ganeti.utils.wrapper_unittest.py \
1317         test/py/ganeti.utils.x509_unittest.py \
1318         test/py/ganeti.utils_unittest.py \
1319         test/py/ganeti.vcluster_unittest.py \
1320         test/py/ganeti.workerpool_unittest.py \
1321         test/py/pycurl_reset_unittest.py \
1322         test/py/qa.qa_config_unittest.py \
1323         test/py/tempfile_fork_unittest.py
1324
1325 haskell_tests = test/hs/htest
1326
1327 dist_TESTS = \
1328         test/py/check-cert-expired_unittest.bash \
1329         test/py/daemon-util_unittest.bash \
1330         test/py/ganeti-cleaner_unittest.bash \
1331         test/py/import-export_unittest.bash \
1332         test/py/cli-test.bash \
1333         test/py/bash_completion.bash
1334
1335 if PY_UNIT
1336 dist_TESTS += $(python_tests)
1337 endif
1338
1339 nodist_TESTS =
1340 check_SCRIPTS =
1341
1342 if WANT_HSTESTS
1343 nodist_TESTS += $(haskell_tests)
1344 dist_TESTS += test/hs/offline-test.sh
1345 check_SCRIPTS += \
1346         test/hs/hpc-htools \
1347         test/hs/hpc-mon-collector \
1348         $(HS_BUILT_TEST_HELPERS)
1349 endif
1350
1351 TESTS = $(dist_TESTS) $(nodist_TESTS)
1352
1353 # Environment for all tests
1354 PLAIN_TESTS_ENVIRONMENT = \
1355         PYTHONPATH=. \
1356         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1357         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1358         $(RUN_IN_TEMPDIR)
1359
1360 # Environment for tests run by automake
1361 TESTS_ENVIRONMENT = \
1362         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1363
1364 all_python_code = \
1365         $(dist_sbin_SCRIPTS) \
1366         $(python_scripts) \
1367         $(pkglib_python_scripts) \
1368         $(nodist_pkglib_python_scripts) \
1369         $(nodist_tools_python_scripts) \
1370         $(pkgpython_PYTHON) \
1371         $(client_PYTHON) \
1372         $(cmdlib_PYTHON) \
1373         $(hypervisor_PYTHON) \
1374         $(storage_PYTHON) \
1375         $(rapi_PYTHON) \
1376         $(server_PYTHON) \
1377         $(pytools_PYTHON) \
1378         $(http_PYTHON) \
1379         $(confd_PYTHON) \
1380         $(masterd_PYTHON) \
1381         $(impexpd_PYTHON) \
1382         $(utils_PYTHON) \
1383         $(watcher_PYTHON) \
1384         $(noinst_PYTHON) \
1385         $(qa_scripts)
1386
1387 if PY_UNIT
1388 all_python_code += $(python_tests)
1389 endif
1390
1391 srclink_files = \
1392         man/footer.rst \
1393         test/py/check-cert-expired_unittest.bash \
1394         test/py/daemon-util_unittest.bash \
1395         test/py/ganeti-cleaner_unittest.bash \
1396         test/py/import-export_unittest.bash \
1397         test/py/cli-test.bash \
1398         test/py/bash_completion.bash \
1399         test/hs/offline-test.sh \
1400         test/hs/cli-tests-defs.sh \
1401         $(all_python_code) \
1402         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1403         $(docinput)
1404
1405 check_python_code = \
1406         $(BUILD_BASH_COMPLETION) \
1407         $(CHECK_IMPORTS) \
1408         $(CHECK_HEADER) \
1409         $(DOCPP) \
1410         $(all_python_code)
1411
1412 lint_python_code = \
1413         ganeti \
1414         ganeti/http/server.py \
1415         $(dist_sbin_SCRIPTS) \
1416         $(python_scripts) \
1417         $(pkglib_python_scripts) \
1418         $(BUILD_BASH_COMPLETION) \
1419         $(CHECK_IMPORTS) \
1420         $(CHECK_HEADER) \
1421         $(DOCPP) \
1422         $(PYTHON_BOOTSTRAP)
1423
1424 standalone_python_modules = \
1425         lib/rapi/client.py \
1426         tools/ganeti-listrunner
1427
1428 pep8_python_code = \
1429         ganeti \
1430         ganeti/http/server.py \
1431         $(dist_sbin_SCRIPTS) \
1432         $(python_scripts) \
1433         $(pkglib_python_scripts) \
1434         $(BUILD_BASH_COMPLETION) \
1435         $(CHECK_HEADER) \
1436         $(DOCPP) \
1437         $(PYTHON_BOOTSTRAP) \
1438         qa
1439
1440 test/py/daemon-util_unittest.bash: daemons/daemon-util
1441
1442 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1443
1444 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1445
1446 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1447         sed -f $(REPLACE_VARS_SED) < $< > $@
1448         chmod +x $@
1449
1450 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1451         sed -f $(REPLACE_VARS_SED) < $< > $@
1452         chmod +x $@
1453
1454 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1455         sed -f $(REPLACE_VARS_SED) < $< > $@
1456         chmod +x $@
1457
1458 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1459         sed -f $(REPLACE_VARS_SED) < $< > $@
1460         chmod +x $@
1461
1462 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1463         sed -f $(REPLACE_VARS_SED) < $< > $@
1464         chmod +x $@
1465
1466 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1467         sed -f $(REPLACE_VARS_SED) < $< > $@
1468         chmod +x $@
1469
1470 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1471         sed -f $(REPLACE_VARS_SED) < $< > $@
1472
1473 doc/examples/bash_completion: BC_ARGS = --compact
1474 doc/examples/bash_completion-debug: BC_ARGS =
1475
1476 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1477         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1478         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1479         daemons/ganeti-cleaner \
1480         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1481         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1482           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1483
1484 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1485         lib/build/shell_example_lexer.py \
1486         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1487         @echo "Checking $< for hardcoded paths..."
1488         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1489           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1490           exit 1; \
1491         fi
1492         set -e ; \
1493         trap 'echo auto-removing $@; rm $@' EXIT; \
1494         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1495         $(CHECK_MAN_REFERENCES) $@; \
1496         trap - EXIT
1497
1498 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1499         @test -n "$(PANDOC)" || \
1500           { echo 'pandoc' not found during configure; exit 1; }
1501         set -o pipefail -e; \
1502         trap 'echo auto-removing $@; rm $@' EXIT; \
1503         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1504           sed -e 's/\\@/@/g' > $@; \
1505         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1506         $(CHECK_MAN_DASHES) $@; \
1507         trap - EXIT
1508
1509 man/%.html.in: man/%.gen man/footer.rst
1510         @test -n "$(PANDOC)" || \
1511           { echo 'pandoc' not found during configure; exit 1; }
1512         set -o pipefail ; \
1513         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1514           sed -e 's/\\@/@/g' > $@
1515
1516 man/%: man/%.in  $(REPLACE_VARS_SED)
1517         sed -f $(REPLACE_VARS_SED) < $< > $@
1518
1519 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1520         sed -f $(REPLACE_VARS_SED) < $< > $@
1521
1522 vcs-version:
1523         if test -d .git; then \
1524           git describe > $@; \
1525         elif test ! -f $@ ; then \
1526           echo "Cannot auto-generate $@ file"; exit 1; \
1527         fi
1528
1529 .PHONY: clean-vcs-version
1530 clean-vcs-version:
1531         rm -f vcs-version
1532
1533 .PHONY: regen-vcs-version
1534 regen-vcs-version:
1535         @set -e; \
1536         cd $(srcdir); \
1537         if test -d .git; then \
1538           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1539           git describe > $$T; \
1540           if ! cmp --quiet $$T vcs-version; then \
1541             mv $$T vcs-version; \
1542           fi; \
1543         fi
1544
1545 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1546         vcs-version $(built_base_sources)
1547         set -e; \
1548         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1549         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1550
1551 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1552         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1553         lib/jstore.py $(RUN_IN_TEMPDIR) \
1554         $(CONVERT_CONSTANTS) $(built_base_sources) \
1555         | lib/_vcsversion.py
1556         set -e; \
1557         { cat $< ; \
1558           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1559         } > $@
1560
1561 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1562         hsc2hs -o $@ $<
1563
1564 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1565         $(built_base_sources)
1566         set -e; \
1567         { cat $< ; \
1568           echo ; \
1569           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1570             echo "import $$name ()" ; \
1571           done ; \
1572         } > $@
1573
1574 lib/_autoconf.py: Makefile | stamp-directories
1575         set -e; \
1576         { echo '# This file is automatically generated, do not edit!'; \
1577           echo '#'; \
1578           echo ''; \
1579           echo '"""Build-time configuration for Ganeti.'; \
1580           echo '';\
1581           echo 'This file is autogenerated by the build process.'; \
1582           echo 'For any changes you need to re-run ./configure (and'; \
1583           echo 'not edit by hand).'; \
1584           echo ''; \
1585           echo '"""'; \
1586           echo ''; \
1587           echo '# pylint: disable=C0301,C0324'; \
1588           echo '# because this is autogenerated, we do not want'; \
1589           echo '# style warnings' ; \
1590           echo ''; \
1591           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1592           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1593           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1594           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1595           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1596           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1597           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1598           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1599           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1600           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1601           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1602           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1603           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1604           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1605           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1606           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1607           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1608           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1609           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1610           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1611           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1612           echo "KVM_PATH = '$(KVM_PATH)'"; \
1613           echo "IP_PATH = '$(IP_PATH)'"; \
1614           echo "SOCAT_PATH = '$(SOCAT)'"; \
1615           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1616           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1617           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1618           echo "TOOLSDIR = '$(toolsdir)'"; \
1619           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1620           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1621           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1622           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1623           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1624           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1625           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1626           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1627           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1628           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1629           echo "RAPI_USER = '$(RAPI_USER)'"; \
1630           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1631           echo "CONFD_USER = '$(CONFD_USER)'"; \
1632           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1633           echo "LUXID_USER = '$(LUXID_USER)'"; \
1634           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1635           echo "NODED_USER = '$(NODED_USER)'"; \
1636           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1637           echo "MOND_USER = '$(MOND_USER)'"; \
1638           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1639           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1640           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1641           echo "HTOOLS = True"; \
1642           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1643           echo "XEN_CMD = '$(XEN_CMD)'"; \
1644           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1645           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1646           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1647 ## Write dictionary with man page name as the key and the section number as the
1648 ## value
1649           echo "MAN_PAGES = {"; \
1650           for i in $(notdir $(man_MANS)); do \
1651             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1652           done; \
1653           echo "}"; \
1654         } > $@
1655
1656 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1657         set -e; \
1658         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1659         { echo '# This file is automatically generated, do not edit!'; \
1660           echo '#'; \
1661           echo ''; \
1662           echo '"""Build-time VCS version number for Ganeti.'; \
1663           echo '';\
1664           echo 'This file is autogenerated by the build process.'; \
1665           echo 'For any changes you need to re-run ./configure (and'; \
1666           echo 'not edit by hand).'; \
1667           echo ''; \
1668           echo '"""'; \
1669           echo ''; \
1670           echo '# pylint: disable=C0301,C0324'; \
1671           echo '# because this is autogenerated, we do not want'; \
1672           echo '# style warnings' ; \
1673           echo ''; \
1674           echo "VCS_VERSION = '$$VCSVER'"; \
1675         } > $@
1676
1677 lib/opcodes.py: Makefile src/hs2py src/Ganeti/Constants.hs \
1678                 lib/opcodes.py.in_before lib/opcodes.py.in_after \
1679                 | stamp-directories
1680         cat $(abs_top_srcdir)/lib/opcodes.py.in_before > $@
1681         src/hs2py >> $@
1682         cat $(abs_top_srcdir)/lib/opcodes.py.in_after >> $@
1683
1684 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1685         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1686
1687 $(SHELL_ENV_INIT): Makefile stamp-directories
1688         set -e; \
1689         { echo '# Allow overriding for tests'; \
1690           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1691           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1692           echo; \
1693           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1694           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1695           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1696           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1697           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1698         } > $@
1699
1700 ## Writes sed script to replace placeholders with build-time values. The
1701 ## additional quotes after the first @ sign are necessary to stop configure
1702 ## from replacing those values as well.
1703 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1704         set -e; \
1705         { echo 's#@''PREFIX@#$(prefix)#g'; \
1706           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1707           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1708           echo 's#@''BINDIR@#$(bindir)#g'; \
1709           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1710           echo 's#@''LIBDIR@#$(libdir)#g'; \
1711           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1712           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1713           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1714           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1715           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1716           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1717           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1718           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1719           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1720           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1721           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1722           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1723           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1724           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1725           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1726           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1727           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1728           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1729           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1730           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1731           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1732           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1733           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1734           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1735           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1736           echo; \
1737           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1738           echo '  r $(SHELL_ENV_INIT)'; \
1739           echo '  d'; \
1740           echo '}'; \
1741         } > $@
1742
1743 # Using deferred evaluation
1744 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1745 daemons/ganeti-watcher: MODULE = ganeti.watcher
1746 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1747 tools/burnin: MODULE = ganeti.tools.burnin
1748 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1749 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1750 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1751 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1752 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1753
1754 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1755         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1756         set -e; \
1757         { echo '#!/usr/bin/python'; \
1758           echo '# This file is automatically generated, do not edit!'; \
1759           echo "# Edit $(MODULE) instead."; \
1760           echo; \
1761           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1762           echo; \
1763           echo '# pylint: disable=C0103'; \
1764           echo '# C0103: Invalid name'; \
1765           echo; \
1766           echo 'import sys'; \
1767           echo 'import $(MODULE) as main'; \
1768           echo; \
1769           echo '# Temporarily alias commands until bash completion'; \
1770           echo '# generator is changed'; \
1771           echo 'if hasattr(main, "commands"):'; \
1772           echo '  commands = main.commands # pylint: disable=E1101'; \
1773           echo 'if hasattr(main, "aliases"):'; \
1774           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1775           echo; \
1776           echo 'if __name__ == "__main__":'; \
1777           echo '  sys.exit(main.Main())'; \
1778         } > $@
1779         chmod u+x $@
1780
1781 $(HS_BUILT_TEST_HELPERS): Makefile
1782         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1783         set -e; \
1784         { echo '#!/bin/sh'; \
1785           echo '# This file is automatically generated, do not edit!'; \
1786           echo "# Edit Makefile.am instead."; \
1787           echo; \
1788           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1789         } > $@
1790         chmod u+x $@
1791
1792 stamp-directories: Makefile
1793         $(MAKE) $(AM_MAKEFLAGS) ganeti
1794         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1795         touch $@
1796
1797 # We need to create symlinks because "make distcheck" will not install Python
1798 # files when building.
1799 stamp-srclinks: Makefile | stamp-directories
1800         set -e; \
1801         for i in $(srclink_files); do \
1802           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1803             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1804           fi; \
1805         done
1806         touch $@
1807
1808 .PHONY: ganeti
1809 ganeti:
1810         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1811
1812 .PHONY: check-dirs
1813 check-dirs: $(GENERATED_FILES)
1814         @set -e; \
1815         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1816           error=; \
1817           while read dir; do \
1818             case "$$dir" in \
1819               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1820               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1821             esac; \
1822           done; \
1823           for dir in $(DIRS); do \
1824             if ! test -d "$$dir"; then \
1825               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1826               error=1; \
1827             fi \
1828           done; \
1829           test -z "$$error"; \
1830         }
1831
1832 .PHONY: check-local
1833 check-local: check-dirs $(GENERATED_FILES)
1834         $(CHECK_PYTHON_CODE) $(check_python_code)
1835         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1836         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1837         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1838         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1839         error= ; \
1840         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1841           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1842           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1843             echo "Incorrect version in README, expected $$expver" >&2; \
1844             error=1; \
1845           fi; \
1846           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1847               doc/security.rst; do \
1848             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1849               "Documents Ganeti version $$expver"; then \
1850               echo "Incorrect version in $$file, expected $$expver" >&2; \
1851               error=1; \
1852             fi; \
1853           done; \
1854           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1855             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1856             error=1; \
1857           fi; \
1858           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1859             ".. Last updated for Ganeti $$expver"; then \
1860             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1861             error=1; \
1862           fi; \
1863         fi; \
1864         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1865           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1866             echo "Longest line in $$file is longer than 80 characters" >&2; \
1867             error=1; \
1868           fi; \
1869         done; \
1870         test -z "$$error"
1871
1872 .PHONY: hs-test-%
1873 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1874         @rm -f htest.tix
1875         test/hs/htest -t $*
1876
1877 .PHONY: hs-tests
1878 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1879         @rm -f htest.tix
1880         ./test/hs/htest
1881
1882 .PHONY: hs-shell-%
1883 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1884             $(HS_BUILT_TEST_HELPERS)
1885         @rm -f hpc-htools.tix hpc-mon-collector.tix
1886         HBINARY="./test/hs/hpc-htools" \
1887         SHELLTESTARGS=$(SHELLTESTARGS) \
1888         ./test/hs/offline-test.sh $*
1889
1890 .PHONY: hs-shell
1891 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1892         @rm -f hpc-htools.tix hpc-mon-collector.tix
1893         HBINARY="./test/hs/hpc-htools" \
1894         SHELLTESTARGS=$(SHELLTESTARGS) \
1895         ./test/hs/offline-test.sh
1896
1897 .PHONY: hs-check
1898 hs-check: hs-tests hs-shell
1899
1900 # E111: indentation is not a multiple of four
1901 # E121: continuation line indentation is not a multiple of four
1902 #       (since our indent level is not 4)
1903 # E125: continuation line does not distinguish itself from next logical line
1904 #       (since our indent level is not 4)
1905 # E127: continuation line over-indented for visual indent
1906 #       (since our indent level is not 4)
1907 # note: do NOT add E128 here; it's a valid style error in most cases!
1908 # I've seen real errors, but also some cases were we indent wrongly
1909 # due to line length; try to rework the cases where it is triggered,
1910 # instead of silencing it
1911 # E261: at least two spaces before inline comment
1912 # E501: line too long (80 characters)
1913 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1914
1915 # For excluding pep8 expects filenames only, not whole paths
1916 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1917
1918 LINT_TARGETS = pylint pylint-qa
1919 if HAS_PEP8
1920 LINT_TARGETS += pep8
1921 endif
1922 if HAS_HLINT
1923 LINT_TARGETS += hlint
1924 endif
1925
1926 .PHONY: lint
1927 lint: $(LINT_TARGETS)
1928
1929 .PHONY: pylint
1930 pylint: $(GENERATED_FILES)
1931         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1932         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1933
1934 .PHONY: pylint-qa
1935 pylint-qa: $(GENERATED_FILES)
1936         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1937         cd $(top_srcdir)/qa && \
1938           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1939           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1940
1941 .PHONY: pep8
1942 pep8: $(GENERATED_FILES)
1943         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1944         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1945           --repeat $(pep8_python_code)
1946
1947 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1948 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1949 .PHONY: hlint
1950 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1951         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1952         @rm -f doc/hs-lint.html
1953         if tty -s; then C="-c"; else C=""; fi; \
1954         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1955           --ignore "Use first" \
1956           --ignore "Use &&&" \
1957           --ignore "Use void" \
1958           --ignore "Reduce duplication" \
1959           --hint src/lint-hints \
1960           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1961         @if [ ! -f doc/hs-lint.html ]; then \
1962           echo "All good" > doc/hs-lint.html; \
1963         fi
1964
1965 # a dist hook rule for updating the vcs-version file; this is
1966 # hardcoded due to where it needs to build the file...
1967 dist-hook:
1968         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1969         rm -f $(top_distdir)/vcs-version
1970         cp -p $(srcdir)/vcs-version $(top_distdir)
1971
1972 # a distcheck hook rule for catching revision control directories
1973 distcheck-hook:
1974         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1975           echo "Found revision control files in final archive." 1>&2; \
1976           exit 1; \
1977         fi
1978         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1979           echo "Found Python byte code in final archive." 1>&2; \
1980           exit 1; \
1981         fi
1982         if find $(top_distdir) -name '*~' | grep .; then \
1983           echo "Found backup files in final archive." 1>&2; \
1984           exit 1; \
1985         fi
1986 # Empty files or directories should not be distributed. They can cause
1987 # unnecessary warnings for packagers. Directories used by automake during
1988 # distcheck must be excluded.
1989         if find $(top_distdir) -empty -and -not \( \
1990             -path $(top_distdir)/_build -or \
1991             -path $(top_distdir)/_inst \) | grep .; then \
1992           echo "Found empty files or directories in final archive." 1>&2; \
1993           exit 1; \
1994         fi
1995         if test -e $(top_distdir)/doc/man-html; then \
1996           echo "Found documentation including man pages in final archive" >&2; \
1997           exit 1; \
1998         fi
1999
2000 # Backwards compatible distcheck-release target
2001 distcheck-release: distcheck
2002
2003 distrebuildcheck: dist
2004         set -e; \
2005         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
2006         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
2007         cd $$builddir; \
2008         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
2009         cd $(distdir); \
2010         ./configure; \
2011         $(MAKE) maintainer-clean; \
2012         cp $(abs_srcdir)/vcs-version .; \
2013         ./configure; \
2014         $(MAKE) $(AM_MAKEFLAGS)
2015
2016 dist-release: dist
2017         set -e; \
2018         for i in $(DIST_ARCHIVES); do \
2019           echo -n "Checking $$i ... "; \
2020           autotools/check-tar < $$i; \
2021           echo OK; \
2022         done
2023
2024 install-exec-local:
2025         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2026           "$(DESTDIR)${localstatedir}/log/ganeti" \
2027           "$(DESTDIR)${localstatedir}/run/ganeti"
2028
2029 .PHONY: apidoc
2030 if WANT_HSAPIDOC
2031 apidoc: py-apidoc hs-apidoc
2032 else
2033 apidoc: py-apidoc
2034 endif
2035
2036 .PHONY: py-apidoc
2037 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2038         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2039         $(RUN_IN_TEMPDIR) epydoc -v \
2040           --conf $(CURDIR)/epydoc.conf \
2041           --output $(CURDIR)/$(APIDOC_PY_DIR)
2042
2043 .PHONY: hs-apidoc
2044 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2045
2046 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2047         @test -n "$(HSCOLOUR)" || \
2048             { echo 'HsColour' not found during configure; exit 1; }
2049         @test -n "$(HADDOCK)" || \
2050             { echo 'haddock' not found during configure; exit 1; }
2051         rm -rf $(APIDOC_HS_DIR)/*
2052         for i in $(ALL_APIDOC_HS_DIRS); do \
2053           @mkdir_p@ $$i; \
2054           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2055         done
2056         set -e ; \
2057         export LC_ALL=en_US.UTF-8; \
2058         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2059         if [ "$(HS_PARALLEL3)" ]; \
2060         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2061         fi; \
2062         if [ "$(HS_REGEX_PCRE)" ]; \
2063         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2064         fi; \
2065         for file in $(HS_LIBTESTBUILT_SRCS); do \
2066           f_nosrc=$${file##src/}; \
2067           f_notst=$${f_nosrc##test/hs/}; \
2068           f_html=$${f_notst%%.hs}.html; \
2069           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2070         done ; \
2071         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2072           -t ganeti -p src/haddock-prologue \
2073           --source-module="%{MODULE/.//}.html" \
2074           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2075           $$OPTGHC \
2076           $(HS_LIBTESTBUILT_SRCS)
2077
2078 .PHONY: TAGS
2079 TAGS: $(GENERATED_FILES)
2080         rm -f TAGS
2081         $(GHC) -e ":etags" -v0 \
2082           $(filter-out -O -Werror,$(HFLAGS)) \
2083           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2084           $(HS_LIBTEST_SRCS)
2085         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2086           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2087           -path './qa/*.py' | \
2088           etags -l python -a -
2089
2090 .PHONY: coverage
2091
2092 COVERAGE_TESTS=
2093 if WANT_HTOOLS
2094 COVERAGE_TESTS += hs-coverage
2095 endif
2096 if PY_UNIT
2097 COVERAGE_TESTS += py-coverage
2098 endif
2099
2100 coverage: $(COVERAGE_TESTS)
2101
2102 .PHONY: py-coverage
2103 py-coverage: $(GENERATED_FILES) $(python_tests)
2104         @test -n "$(PYCOVERAGE)" || \
2105             { echo 'python-coverage' not found during configure; exit 1; }
2106         set -e; \
2107         COVERAGE=$(PYCOVERAGE) \
2108         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2109         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2110         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2111         $(PLAIN_TESTS_ENVIRONMENT) \
2112         $(abs_top_srcdir)/autotools/gen-py-coverage \
2113         $(python_tests)
2114
2115 .PHONY: hs-coverage
2116 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2117         rm -f *.tix
2118         $(MAKE) $(AM_MAKEFLAGS) hs-check
2119         @mkdir_p@ $(COVERAGE_HS_DIR)
2120         hpc sum --union $(HPCEXCL) \
2121           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2122         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2123         hpc report coverage-hs.tix
2124         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2125
2126 # Special "kind-of-QA" target for htools, needs special setup (all
2127 # tools compiled with -fhpc)
2128 .PHONY: live-test
2129 live-test: all
2130         set -e ; \
2131         cd src; \
2132         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2133         rm -f *.tix *.mix; \
2134         ./live-test.sh; \
2135         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2136           --output=live-test.tix ; \
2137         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2138         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2139           --srcdir=.. $(HPCEXCL) ; \
2140         hpc report --srcdir=.. live-test $(HPCEXCL)
2141
2142 commit-check: autotools-check distcheck lint apidoc
2143
2144 autotools-check:
2145         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2146   $(abs_top_srcdir)/test/autotools/*-*.test \
2147   -- --hide-successes
2148
2149 .PHONY: gitignore-check
2150 gitignore-check:
2151         @if [ -n "`git status --short`" ]; then \
2152           echo "Git status is not clean!" 1>&2 ; \
2153           git status --short; \
2154           exit 1; \
2155         fi
2156
2157 # target to rebuild all man pages (both groff and html output)
2158 .PHONY: man
2159 man: $(man_MANS) $(manhtml)
2160
2161 # Target that builds all binaries (including those that are not
2162 # rebuilt except when running the tests)
2163 .PHONY: really-all
2164 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2165
2166 # we don't need the ancient implicit rules:
2167 %: %,v
2168 %: RCS/%,v
2169 %: RCS/%
2170 %: s.%
2171 %: SCCS/s.%
2172
2173 -include ./Makefile.local
2174
2175 # vim: set noet :